/*
 *  MemoryRecorder.h
 *  _crono3
 *
 *  Created by trollback on 4/12/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#include "ofMain.h"

class MemoryRecorder {
public:	

	void drawInfo(ofTrueTypeFont *);  
    void init(int x, int y, int w, int h);
	void setSize(int w, int h);
	void setPosition(int w, int h, bool animate);

	
	
	void setFromPixels(unsigned char* _pixels, int w, int h);
	void draw();
	void update();
	void clear();
	
	int getWidth();
	int getHeight();
	
	int getXpos();
	int getYpos();
	
	void setOffset(int n);
	void record();
	void play();
    
    int getNumFrames();
	
	void setColumn(int n);
	void setRow(int n);

	int getColumn();
	int getRow();
	
	int column;
	int row;
	
	int width;
	int height;
	float xpos;
	float ypos;

	float new_x;
	float new_y;
	
	bool isRecording;
	int currentFrame;
	
	int imageLength;
	
	int currentframe;
	
	int framestep;
	int framerest;
	int framecounter;	
	
	int bufferThreshold;
	
	vector <unsigned char*> imageList;
	
	unsigned char* getFrame();	
    
    int max_frames;

    
    ofImage img;
    unsigned char* px;
    void allocatePixels(unsigned char* &pix, int width, int height, int bpp);
	void onCompleteX(float args);
	void onCompleteY(float args);
};