/*
 *  photo.h
 *  iPhoneVidGrabberExample
 *
 *  Created by trollback on 4/4/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

/*
 *  untitled.h
 *  opencvExample
 *
 *  Created by trollback on 3/11/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 
 */

#include "ofxOpenCv.h"


class Photo {
public:	
	
    void init(int w, int h);
	void setSize(int w, int h);
	void fadeTo(float start, float end);
	void setFromPixels( unsigned char* _pixels, int w, int h );
	void draw(int x, int y);
	void update();
	void clear();
	void fadeComplete(float args);
	void grabScreen(int x, int y);
	void resize(int w, int h);
	void saveImage(string filename);
	void loadImage(string filename);
	ofImage image;
	
	void setBlur(int b, int br);
	
	float blur;
	float blurreverse;
	int xpos, ypos;
	int width, height;
	bool inited;
	float alpha;
	
	
	void addPixels_lighten( unsigned char* _pixels, int w, int h );
	void previewImage(unsigned char* _pixels, unsigned char* currentpixels, int w, int h);
	int*  blend_soft_light(int ar, int ag, int ab, int br, int bg, int bb);
	
	int blend_screen(int a, int b);
	int blend_lighten(int a, int b);	
	int blend_soft_light(int a, int b);
	int blend_overlay(int a, int b);
	int blend_darken(int a, int b);
	int blend_multiply(int a, int b);
	
	int getWidth();
	int getHeight();
	
	int blendModeInt;
	
	void setBlendMode(int b);
	virtual unsigned char* getPixels();
	
	
	
};