//
//  TextLabel.cpp
//  20_AICP
//
//  Created by Stephen Baker on 9/6/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#include <iostream>
#include "TextLabel.h"

//(1-pct)*a + (pct)*b;

void TextLabel::init(string s, ofTrueTypeFont * f) {
    cout << "add font ++++ " << s << endl;
    Tweenzor::init();
    str = s;
    xpos = 100;
    ypos = 300;
    font = f;
    alpha = ofRandom(0.0, 1.0); 
}

void TextLabel::update() {	
    Tweenzor::update();
}

void TextLabel::draw() {
    
    int a = alpha*255.0f;
    
    //cout << " a " << a << endl;
    
    ofSetColor(255,255,255, a);
	font->drawString(str, xpos, ypos); 
}

void TextLabel::setPosition(int x_in, int y_in){
    xpos = x_in;
    ypos = y_in;
}

int TextLabel::getWidth(){
    int w = font->stringWidth(str);
    return w;
}

void TextLabel::fade(){
    float alpha_anim = 0.0;
    
    if((alpha < 0.1)){
        alpha_anim = 1.0;
    }
    
    Tweenzor::add( &alpha, alpha, alpha_anim, 0.0f, 1.0f, EASE_OUT_SINE);

}
